package server;

import java.io.File;
import java.io.IOException;
import java.util.Hashtable;

public class PersistMessageQueueManager{

	protected static PersistMessageQueueManager queueManager;
	protected static String queueDirectoryName= "queues"; // the directory where the queue files are located

	private Hashtable queueList;
	
	private PersistMessageQueueManager() {
		queueList = new Hashtable();
		initPersistStorage();
	}
	
	/**
	 * Individual queues are stored in the queue directory.
	 * Check and read all the queue files, restore the state
	 * of the queues.
	 */
	private void initPersistStorage() {
		// TO BE IMPLEMENTED
	}

	public static PersistMessageQueueManager instance() {
		if (queueManager == null) {
			queueManager = new PersistMessageQueueManager();
		}
		return queueManager;
	}

	/**
	 * Create a queue with a specified name
	 * @param name
	 * @return true if successful
	 * 	   false if the queue with the name already exists
	 */
	protected boolean createQueue(String name) {
		// TO BE IMPLEMENTED
	}

	/**
	 * Delete a queue with a specified name
	 * @param name
	 * @return true if successful
	 *         false if the queue doesn't exist
	 */
	protected boolean deleteQueue(String name) {
		// TO BE IMPLEMENTED
	}

	/**
	 * Find a queue with a specified name
	 * @param name
	 * @return false if not found
	 */
	protected PersistMessageQueue getQueue(String name) {
		// TO BE IMPLEMENTED
	}
}
